package de.ozgcloud.processor.vorgang;

import static org.mockito.Mockito.*;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.mock.mockito.MockBean;
import org.springframework.context.ApplicationEventPublisher;

import de.itvsh.kop.common.test.ITCase;
import de.itvsh.ozg.pluto.command.VorgangCreatedEvent;
import de.ozgcloud.apilib.vorgang.OzgCloudVorgangTestFactory;
import de.ozgcloud.processor.processor.ProcessorService;
import de.ozgcloud.processor.result.ResultService;

@ITCase
class VorgangEventListenerITCase {

	@Autowired
	private ApplicationEventPublisher publisher;

	@MockBean
	private ResultService resultService;
	@MockBean
	private VorgangService service;
	@MockBean
	private ProcessorService processorService;

	@Test
	void shouldLoadVorgang() {
		when(service.getVorgang(any())).thenReturn(VorgangTestFactory.create());
		var event = new VorgangCreatedEvent(OzgCloudVorgangTestFactory.ID.toString());

		publisher.publishEvent(event);

		verify(service).getVorgang(VorgangId.from(OzgCloudVorgangTestFactory.ID.toString()));
	}


}
